'use strict';

var letters = 'abcdefghijklmnopqrstuvwxyz';
var numbers = '0123456789';

function pred() {
  var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  var result = '';
  var carry = false;

  var i = this.length;
  while (i--) {
    var char = this.charAt(i);

    var letterPos = letters.indexOf(char.toLowerCase());
    if (letterPos > 0) {
      var _pred = letters[letterPos - 1];
      var isUpper = char === char.toUpperCase();
      result = (isUpper ? _pred.toUpperCase() : _pred).concat(result);
      carry = false;
      break;
    }
    if (letterPos === 0) {
      var _pred2 = letters[letters.length - 1];
      var _isUpper = char === char.toUpperCase();
      result = (_isUpper ? _pred2.toUpperCase() : _pred2).concat(result);
      carry = true;
      continue;
    }

    var numberPos = numbers.indexOf(char);
    if (numberPos > 0) {
      result = numbers[numberPos - 1].concat(result);
      carry = false;
      break;
    }
    if (numberPos === 0) {
      result = numbers[numbers.length - 1].concat(result);
      carry = true;
      continue;
    }

    result = char.concat(result);
  }

  result = i === -1 ? result : this.substring(0, i).concat(result);

  var startsWithLetter = letters.includes(result.charAt(0).toLowerCase());
  if (carry && startsWithLetter) {
    return result.substring(1);
  }

  return result;
}

String.prototype.pred = String.prototype.pred || pred;